HDU--2955--Robberies--01背包

21 篇文章 0 订阅

Robberies

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 12968    Accepted Submission(s): 4799


Problem Description
The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.


For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.


His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.
 

Input
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .
 

Output
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.
 

Sample Input
  
  
3 0.04 3 1 0.02 2 0.03 3 0.05 0.06 3 2 0.03 2 0.03 3 0.05 0.10 3 1 0.03 2 0.02 3 0.05
 

Sample Output
  
  
2 4 6

题意:给你一个被抓到的概率P和各个银行的信息,银行信息为拥有的钱V和来偷钱被抓的概率,要求的是不被抓到情况下能偷到的钱最多是多少

解析:直接求被抓概率很麻烦,所以换成求不被抓的,那就是每次偷钱都不被抓的概率,这样就方便多了,然后用01背包的做法就可以KO之!


#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
int main (void)
{
    int t,n,m,i,j,k,l;
    double P,p[111],dp[11111];
    int v[111];
    scanf("%d",&t);
    while(t--&&scanf("%lf%d",&P,&n)!=EOF)
    {
        P=1-P;	//换算成不被抓的概率
        m=0;
        for(i=0;i<n;i++)
        {
            scanf("%d%lf",&v[i],&p[i]);
            p[i]=1-p[i];
            m+=v[i];	//求出所有银行的总钱数,因为背包以钱为下标
        }
        memset(dp,0,sizeof(dp));
        dp[0]=1;	//偷到钱=0的时候安全概率是1,即还没偷的时候
        for(i=0;i<n;i++)
        {
            for(j=m;j>=v[i];j--)
            {
                if(dp[j]<dp[j-v[i]]*p[i])
                dp[j]=dp[j-v[i]]*p[i];
            }
        }
        while(m>=0)	//遍历所有金钱量,这里要记得把0算进来,可能没有偷到任何银行的情况
        {
            if(dp[m]>=P)	//P已经换算成了安全概率,所以只要不被抓的概率大于或者等于它就安全
            {
                printf("%d\n",m);
                break;
            }
            m--;
        }
    }
    return 0;
}
总结:开始因为是英文题,所以没有好好看,理解成了概率相加小于那个概率p就行了,我想说,能不能给点有建设性的测试数据?这是在考大伙的编程思维还是读题啊!!


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值